const {
  csv,
  select,
  scaleLinear,
  extent,
  axisLeft,
  axisBottom,
  zoom,
  event,
  format, min, max,brush
} = d3;

import { menu } from './menu'
import {scatterPlot} from './scatterPlot'


const csvUrl = [
  'https://gist.githubusercontent.com/',
  'LeahMitchell/', // User
  '8ad46fbcac8d7420bcd5b97b1a245f43/', // Id of the Gist
  'raw/365703549f7c73f187ab0666b0754148a4fa9d06/', // commit
  'marvel_data.csv', // File name
].join('');



const parseRow = (d) => {
  d.Height = +0.0328084 *d.Height;
  d.Weight = +d.Weight;
  d.Intelligence = +d.Intelligence_x;
  d.Strength = +d.Strength;
  d.Speed = +d.Speed;
  d.Durability = +d.Durability_x;
  d.Power = +d.Power;
  d.Combat = +d.Combat;
  d.Total = +d.Total;
  d.Name = d.Name;
  d.Alignment_x = d.Alignment_x;
  return d;
};




const width = window.innerWidth;
console.log(width);
const height = window.innerHeight;
const margin = {
      top: 50,
      right: 150,
      bottom: 40,
      left: 50,
};


const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

// const menuContainer = select('body')
//   .append('div')
//   .attr('class', 'menu-container');

// const xMenu = menuContainer.append('div');
// const yMenu = menuContainer.append('div');

const main = async () => {
   const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.Strength)
    .yValue((d) => d.Height)
   	.Name((d) => d.Name)
   	.Total((d) => d.Total)
   	.Side((d) => d.Alignment_x)
    .margin(margin);
    // .radius(5);
  
  
  svg.call(plot)
  
  
  const options = [ 
    {
      value: 'Strength',
      text: 'Strength Score',
      type: 'quantitative',
    },
    {
      value: 'Intelligence',
      text: 'Intelligence Score',
      type: 'quantitative',
    },
    {
      value: 'Speed',
      text: 'Speed Score',
      type: 'quantitative',
    },
    {
      value: 'Durability',
      text: 'Durability Score',
      type: 'quantitative',
    },
    {
      value: 'Power',
      text: 'Power Score',
      type: 'quantitative',
    },
    {
      value: 'Combat',
      text: 'Combat Score',
      type: 'quantitative',
    },
  ];
 
  
//   const columnToType = new Map(
//     options.map(({ value, type }) => [value, type])
//   );
//   options.forEach((option) => {
//     columnToType.set(option.value, option.type);
//   });

//   // column is a string, corresponding to
//   // the value property on metadata objects.
//   const getType = (column) => columnToType.get(column);

  // xMenu.call(
  //   menu()
  //     .id('x-menu')
  //     .labelText('X:')
  //     .options(options)
  //     .on('change', (column) => {
  //       console.log(getType(column));
  //       svg.call(
  //         plot
  //           .xValue((d) => d[column])
  //           .xType(getType(column))
  //       );
  //     })
  // );
  // yMenu.call(
  //   menu()
  //     .id('y-menu')
  //     .labelText('Y:')
  //     .options(options)
  //     .on('change', (column) => {
  //       svg.call(
  //         plot
  //           .yValue((d) => d[column])
  //           .yType(getType(column))
  //       );
  //     })
  // );
  
};
main();
