import {
  scaleLinear,
  extent,
  axisLeft,
  axisBottom,
  max,
  min,
  scalePoint,
  transition,
  brush,
  format,
} from 'd3';

import { useRef, useEffect } from 'react';

export const scatterPlot = () => {
  let width;
  let height;
  let data;
  let xValue;
  let yValue;
  let xType;
  let yType;
  let Name;
  let Side;
  let Total;
  let margin;

  const my = (selection) => {
    //     const x = (xType === 'categorical'
    //       ? scalePoint().domain(data.map(xValue)).padding(0.2)
    //       : scaleLinear().domain(extent(data, xValue))
    //     ).range([margin.left, width - margin.right]);

    //     // const xAxis = selection
    //     //   .append('g')
    //     //   .attr(
    //     //     'transform',
    //     //     `translate(0,${height - margin.bottom})`
    //     //   )
    //     //   .call(axisBottom(x));

    //     const y = (yType === 'categorical'
    //       ? scalePoint().domain(data.map(yValue)).padding(0.2)
    //       : scaleLinear().domain(extent(data, yValue))
    //     ).range([height - margin.bottom, margin.top]);

    const x = scaleLinear()
      .domain(extent(data, xValue))
      .range([margin.left, width - margin.right - 15]);

    const y = scaleLinear()
      .domain(extent(data, yValue))
      .range([height - margin.bottom, margin.top + 15]);

    const marks = data.map((d) => ({
      x_val: x(xValue(d)),
      y_val: y(yValue(d)),
      Name: Name(d),
      Side: Side(d),
      Total: Total(d),
    }));

    const Total_Max = max(data, Total);
    const Total_Min = min(data, Total);

    const colorPicker = (d) => {
      if (d == 'good') {
        return 'green';
      } else if (d == 'bad') {
        return 'darkred';
      } else {
        return 'grey';
      }
    };

    // size by total value function!!
    const radius_size = (d) => {
      return (
        10 * ((d - Total_Min) / (Total_Max - Total_Min))
      );
    };
    const t = transition().duration(500);

    //     const positionCircles = (circles) => {
    //       circles.attr('cx', (d) => d.x_val).attr('cy', (d) => d.y_val);
    //     };

    //     const initializeRadius = (circles) => {
    //       circles.attr('r', 0);
    //     };
    //     const growRadius = (enter) => {
    //       enter
    //         .transition(t)
    //         .attr('r', (d) => radius_size(d.Total));
    //     };

    //     const create_color = (circles) => {
    //       circles.attr('fill', (d) => colorPicker(d.Side));
    //       circles.attr('opacity', 0.4);
    //     };
    //     const add_name = (circles) => {
    //       circles.append('title').text((d) => d.Name);
    //     };

    // clipPath
    const clip = selection
      .append('defs')
      .append('svg:clipPath')
      .attr('id', 'clip')
      .append('svg:rect')
      .attr('width', width - margin.left - margin.right)
      .attr('height', height - margin.bottom - margin.top)
      .attr('x', margin.left)
      .attr('y', margin.top);

    // brushing
    const brush = d3
      .brushX()
      .extent([
        [0, 0],
        [width, height],
      ]) // initialise the brush area
      .on('end', updateChart); // update chart on brush selection change

    // var elem = selection
    //   .selectAll('g myCircleText')
    //   .data(data);
    
    const circles = selection
      .append('g')
      .attr('clip-path', 'url(#clip)');

    // var elemEnter = elem
    //   .enter()
    //   .append('g')
    // 	.attr('clip-path', 'url(#clip)')
    //   .attr('transform', function (d) {
    //     return 'translate(' + x(xValue(d)) + ',80)';
    //   });

  circles
      .selectAll('circle')
      .data(data)
      .enter()
      .append('circle')
      .attr('cx', (d) => x(xValue(d)))
      .attr('cy', (d) => y(yValue(d)))
      .attr('fill', (d) => colorPicker(Side(d)))
      .attr('r', (d) => radius_size(Total(d)))
      .attr('opacity', 0.4);

//     var points = elemEnter
//       .append('circle')
//       .attr('r', (d) => radius_size(Total(d)))
//       .attr('cx', (d) => x(xValue(d)))
//       .attr('cy', (d) => y(yValue(d)))
//       .attr('stroke', 'black')
//       .attr('fill', (d) => colorPicker(d.Side))
//       .attr('class', 'points')
//       .attr('opacity', 0.4);
    
    
//     elemEnter
//       .append('text')
//       .attr('dx', (d) => x(xValue(d)))
//       .attr('dy', (d) => y(yValue(d)))
//       .text("hello")
//       .attr('stroke', (d) => colorPicker(d.Side));
    
    
    /*Create and place the "blocks" containing the circle and the text */
//     var elemEnter = elem
//       .enter()
//       .append('g')
//       .attr('transform', function (d) {
//         return 'translate(' + x(xValue(d)) + ',80)';
//       });

//     //     /*Create the circle for each block */
//     var points = elemEnter
//       .append('circle')
//       .attr('r', (d) => radius_size(Total(d)))
//       .attr('cx', (d) => x(xValue(d)))
//       .attr('cy', (d) => y(yValue(d)))
//       .attr('stroke', 'black')
//       .attr('fill', (d) => colorPicker(d.Side))
//       .attr('class', 'points')
//       .attr('opacity', 0.4);
//     /* Create the text for each block */

    // elemEnter
    //   .append('text')
    //   .attr('dx', (d) => x(xValue(d)))
    //   .attr('dy', (d) => y(yValue(d)))
    //   .text((d) => d.Name)
    //   .attr('stroke', (d) => colorPicker(d.Side));

    selection
      .selectAll('.y-axis')
      .data([null])
      .join('g')
      .attr('class', 'y-axis')
      .attr('transform', `translate(${margin.left},0)`)
      .transition(t)
      .call(axisLeft(y));

    selection
      .selectAll('.x-axis')
      .data([null])
      .join('g')
      .attr('class', 'x-axis')
      .attr(
        'transform',
        `translate(0,${height - margin.bottom})`
      )
      .transition(t)
      .call(axisBottom(x));

    selection
      .append('text')
      .attr('x', width / 2)
      .attr('y', height - 470)
      .text('Are taller characters stronger?')
      .style('font-size', '28px')
      .attr('text-anchor', 'middle');
    selection
      .append('text')
      .attr('x', margin.right - 100)
      .attr('y', margin.top - 5)
      .text('Character Height (ft)');
    selection
      .append('text')
      .attr('x', width - margin.right - 50)
      .attr('y', height - margin.bottom - 5)
      .text('Character Strength');

    circles.append('g').attr('class', 'brush').call(brush);

    let idleTimeout;
    function idled() {
      idleTimeout = null;
    }

    function updateChart(e) {
      const sel = e.selection;
      if (!sel) {
        // no selection then initial coordinates
        if (!idleTimeout)
          // wait
          return (idleTimeout = setTimeout(idled, 350));
        x.domain(extent(data, xValue));
      } else {
        // update X axis domain
        x.domain([x.invert(sel[0]), x.invert(sel[1])]);
        // remove the grey brush area after selection
        circles.select('.brush').call(brush.move, null);
      }

      // update x-axis
      selection
        .selectAll('.x-axis')
        .transition()
        .duration(1000)
        .call(d3.axisBottom(x));

      // update circle position
      circles
        .selection()
        .selectAll('circle')
        .transition()
        .duration(1000)
        .attr('cx', function (d) {
          return x(xValue(d));
        });

      //       const circles = selection
      //       .selectAll('circle')
      //       .data(marks)
      //       .join(
      //         (enter) =>
      //           enter
      //             .append('circle')
      //             .call(positionCircles)
      //             .call(initializeRadius)
      //             .call(create_color)
      //             .call(add_name)
      //             .call(growRadius),
      //         (update) =>
      //           update.call((update) =>
      //             update
      //               .transition(t)
      //               .delay((d, i) => i * 10)
      //               .call(positionCircles)
      //           ),
      //         (exit) => exit.remove()
      //       );
    }
  };

  my.width = function (_) {
    return arguments.length ? ((width = +_), my) : width;
  };

  my.height = function (_) {
    return arguments.length ? ((height = +_), my) : height;
  };

  my.data = function (_) {
    return arguments.length ? ((data = _), my) : data;
  };

  my.xValue = function (_) {
    return arguments.length ? ((xValue = _), my) : xValue;
  };

  my.yValue = function (_) {
    return arguments.length ? ((yValue = _), my) : yValue;
  };

  my.xType = function (_) {
    return arguments.length ? ((xType = _), my) : xType;
  };

  my.yType = function (_) {
    return arguments.length ? ((yType = _), my) : yType;
  };

  my.margin = function (_) {
    return arguments.length ? ((margin = _), my) : margin;
  };

  my.Name = function (_) {
    return arguments.length ? ((Name = _), my) : Name;
  };

  my.Total = function (_) {
    return arguments.length ? ((Total = _), my) : Total;
  };

  my.Side = function (_) {
    return arguments.length ? ((Side = _), my) : Side;
  };

  return my;
};
